using Dapfor.Net.Data;
using Dapfor.Net.Formats;
using Dapfor.Net.Grid.Tutorial.Formats;

namespace Dapfor.Net.Grid.Tutorial.BusinessData.CAC40
{
    public class Instrument
    {
        public const string FieldInstrumentId = "InstrumentId";

        private readonly double _capitalization;
        private readonly string _isin;
        private readonly string _mnemo;
        private readonly string _name;
        private readonly long _shares;
        private readonly double _weight;
        private readonly string _currency;

        public Instrument(string name, string isin, string mnemo, long shares, double capitalization, double weight, string currency)
        {
            _name = name;
            _shares = shares;
            _isin = isin;
            _mnemo = mnemo;
            _shares = shares;
            _capitalization = capitalization;
            _weight = weight;
            _currency = currency;
        }

        public string Name
        {
            get { return _name; }
        }

        [Field(FieldInstrumentId)]
        public string Isin
        {
            get { return _isin; }
        }

        public string Mnemo
        {
            get { return _mnemo; }
        }

        [Format(typeof(NumericFormat))]
        public long Shares
        {
            get { return _shares; }
        }

        [Format(typeof(NumericFormat))]
        public double Capitalization
        {
            get { return _capitalization; }
        }

        [DoubleFormat(2, false, false)]
        public double Weight
        {
            get { return _weight; }
        }

        public string Currency
        {
            get { return _currency; }
        }
    }
}