using System;
using System.Collections.Generic;
using System.ComponentModel;

namespace Dapfor.Net.Grid.Tutorial.BusinessData.Currencies
{
    /// <summary>
    /// Provides an overridden collection of CurrencyRate properties
    /// </summary>
    internal class CurrencyRateTypeDescriptor : CustomTypeDescriptor
    {
        private readonly ICustomTypeDescriptor _baseDescriptor;

        public CurrencyRateTypeDescriptor(ICustomTypeDescriptor baseDescriptor)
        {
            _baseDescriptor = baseDescriptor;
        }

        public override PropertyDescriptorCollection GetProperties()
        {
            List<PropertyDescriptor> propertyDescriptor = new List<PropertyDescriptor>();
            
            //Add existing properties
            foreach (PropertyDescriptor descriptor in _baseDescriptor.GetProperties())
            {
                propertyDescriptor.Add(descriptor);
            }

            //Add new properties
            foreach (string currency in Provider.Instance.AvailableCurrencies)
            {
                propertyDescriptor.Add(new CurrencyRatePropertyDescriptor(currency, null));
            }
            return new PropertyDescriptorCollection(propertyDescriptor.ToArray());
        }

        public override PropertyDescriptorCollection GetProperties(Attribute[] attributes)
        {
            return GetProperties();
        }
    }
}