using System.Collections;
using System.Collections.Generic;
using System.ComponentModel;
using Dapfor.Net.Grid.Tutorial.BusinessData.OrderBook;

namespace Dapfor.Net.Grid.Tutorial.BusinessData
{
    /// <summary>
    /// Enables to combine multiple data sources (Orders and Strategies) at the same hierarchical level
    /// </summary>
    public class MultipleDataSources : IListSource
    {
        private readonly IList _sources;

        public MultipleDataSources(IList<Order> orders, IList<Strategy> strategies)
        {
            _sources = new ArrayList();
            _sources.Add(orders);
            _sources.Add(strategies);
        }

        #region IListSource Members

        public IList GetList()
        {
            return _sources;
        }

        public bool ContainsListCollection
        {
            get { return true; }
        }

        #endregion
    }
}