using System;
using Dapfor.Net.Data;
using Dapfor.Net.Formats;
using Dapfor.Net.Grid.Tutorial.BusinessData.CAC40;

namespace Dapfor.Net.Grid.Tutorial.BusinessData.OrderBook
{
    public class Deal
    {
        private readonly Order _order;
        private readonly string _dealId;
        private readonly DateTime _timeStamp;
        private readonly double _price;
        private readonly long _quantity;
        private readonly string _counterpart;

        public Deal(Order order, string dealId, double price, long quantity, string counterpart)
        {
            _order = order;
            _dealId = dealId;
            _timeStamp = DateTime.Now;
            _price = price;
            _quantity = quantity;
            _counterpart = counterpart;
        }

        [CompositeField]
        public Instrument Instrument
        {
            get { return _order.Instrument; }
        }
        
        public Order Order
        {
            get { return _order; }
        }

        [Field("Id")]
        public string DealId
        {
            get { return _dealId; }
        }

        [Field("TimeStamp")]
        public DateTime TimeStamp
        {
            get { return _timeStamp; }
        }

        [DoubleFormat(3)]
        public double Price
        {
            get { return _price; }
        }

        public long Quantity
        {
            get { return _quantity; }
        }

        public string Counterpart
        {
            get { return _counterpart; }
        }
    }

}
