using System;
using System.Windows.Forms;
using Dapfor.Net.Grid.Tutorial.BusinessData;
using Dapfor.Net.Grid.Tutorial.BusinessData.CAC40;
using Dapfor.Net.Theming;
using Dapfor.Net.Ui;

namespace Dapfor.Net.Grid.Tutorial.Presentation
{
    public partial class InstrumentBrowser : UserControl
    {
        private string _isinFilter;
        private string _currencyFilter;

        public InstrumentBrowser()
        {
            InitializeComponent();

            grid.Filter = new Filter(OnFilterData);
            grid.Theme = Theme.Default;
        }

        private bool OnFilterData(Row row)
        {
            Instrument instrument = (Instrument) row.DataObject;
            bool visible = string.IsNullOrEmpty(_isinFilter) || instrument.Isin.Contains(_isinFilter);
            visible = visible && (string.IsNullOrEmpty(_currencyFilter) || instrument.Currency.Contains(_currencyFilter));

            return !visible;
        }


        protected override void OnLoad(EventArgs e)
        {
            base.OnLoad(e);

            //Bind grid to instruments in the run-time.
            if(!DesignMode)
            {
                grid.DataSource = Provider.Instance.Instruments;                
            }
        }

        private void tbIsin_TextChanged(object sender, EventArgs e)
        {
            _isinFilter = tbIsin.Text.ToUpper();
            grid.FilterRefresh();
        }

        private void tbCurrency_TextChanged(object sender, EventArgs e)
        {
            _currencyFilter = tbCurrency.Text.ToUpper();
            grid.FilterRefresh();
        }
    }
}